import numpy as np
import matplotlib.pyplot as plt
from matplotlib.ticker import MaxNLocator
from collections import namedtuple
import os

n_groups = 10

Algos = ["TPCH1", "TPCH4", "TPCH13", "TPCH16","TPCH21", "","KMEANS", "LR", "TPCH6","TPCH11"]
# Algos = ["LR", "KMeans", "TPCH1", "TPCH4", "TPCH6","TPCH11","TPCH13","TPCH16","TPCH21"]
SYS = [r"UPA-$\epsilon_{1}$",r"FLEX-$\epsilon_{1}$", r"UPA-$\epsilon_{200}$",r"FLEX-$\epsilon_{200}$"]

# 	LR	Kmeans	SVM	TPCHQuery1	TPCHQuery3
# FLEX	na	na	na	0.1	1000
					
# Matryoshka	0.05	0.47	0.05	0.4	28

upa_data_1 = (0.000162004, 0.016858557, 0.000153138, 0.047723891, 0.034121457, 0, 0.004340471, 0.121586031, 0.000161873, 0.001344586)

flex_data_1 = (0.000159506, 0.002682237, 0.004584646, 62.49947622, 248.2704339, 0, 0.0, 0.0,  0.0, 0.0)

upa_data_200 = (0.001927856, 0.591293153, 0.017958067, 1.555130883, 0.055720096, 0, 0.792882176, 1.813879521, 0.008645138, 0.009171303)

flex_data_200 = (0.002154974, 1.889025886, 3.2854407, 103210.9401, 37608429225, 0, 0.0, 0.0,  0.0, 0.0)

fig, ax = plt.subplots()

index = np.arange(n_groups)
bar_width = 0.35

opacity = 1

ax.set_yscale("log", nonposy='clip')

k = .50

upa_bar_200 = ax.bar(index + bar_width * 2*k, upa_data_200, bar_width * k,
                alpha=opacity, color='#FF3933', edgecolor='#000000', label=SYS[2], hatch="...")

flex_bar_200 = ax.bar(index + bar_width * 3*k, flex_data_200, bar_width * k,
                alpha=opacity, color='#FFE633', edgecolor='#000000', label=SYS[3])                

upa_bar_1 = ax.bar(index, upa_data_1, bar_width * k,
                alpha=opacity, color='#ffbfc0', edgecolor='#000000', label=SYS[0], hatch="////")

flex_bar_1 = ax.bar(index + bar_width * k, flex_data_1, bar_width * k,
                alpha=opacity, color='#FEFFBF', edgecolor='#000000', label=SYS[1])

ax.set_xlabel('Application', fontsize=18)
ax.set_ylabel('Median Error (%)', fontsize=16)

ax.plot(range(0,10), [10 for i in range(0,10)], color='blue', linestyle='dashed', label="Accurate (< 10% error)")

# ax.text(-0.55, 6e-10, "0.0",fontsize=13)
# ax.text(0.55, 6e-10, "0.0",fontsize=8)
# ax.text(5.4, 6e-10, "N/A",fontsize=13)
# ax.text(6.4, 6e-10, "N/A",fontsize=13)
# ax.text(7.4, 6e-10, "N/A",fontsize=13)
# ax.text(8.4, 6e-10, "N/A",fontsize=13)
ax.tick_params(axis='x', which='major', labelsize=13)
ax.tick_params(axis='y', which='major', labelsize=15)
# ax.set_yticks(np.arange(1,8))
# ax.set_yticklabels(np.arange(1,8))
ax.set_xticks(index + bar_width * .27)
ax.set_xticklabels(Algos,rotation=40)
ax.legend(loc='upper left',fontsize=15)

fig.tight_layout()
plt.savefig(os.path.basename(__file__).replace(".py", ".pdf"))