import numpy as np
import matplotlib.pyplot as plt
from matplotlib.ticker import MaxNLocator
from collections import namedtuple
import os

n_groups = 9

Algos = ["LR", "KMeans", "TPCH1", "TPCH4", "TPCH6","TPCH11","TPCH13","TPCH16","TPCH21"]
SYS = ["FLEX", "UPA"]

# 	LR	Kmeans	SVM	TPCHQuery1	TPCHQuery3
# FLEX	na	na	na	0.1	1000
					
# Matryoshka	0.05	0.47	0.05	0.4	28

# flex_data = (0.0, 0.0, 0.0, 1.75, 0.0, 0.0, 0.0, 2.93, 8.15)

upa_data = (78.1, 85.7, 127.4, 53.3, 130.9, 46.5, 106.5, 51.5, 19.1)

# upa_data = (7.1, 1.9, 83.9, 26.2, 90.8, 15.8, 66.6, 20.5, 8.6)

fig, ax = plt.subplots()

index = np.arange(n_groups)
bar_width = 0.35

opacity = 1

# ax.set_yscale("log", nonposy='clip')

k = .50
# flex_bar = ax.bar(index, flex_data, bar_width * k,
#                 alpha=opacity, color='#FEFFBF', edgecolor='#000000', label=SYS[0])

ss_bar = ax.bar(index, upa_data, bar_width * 0.8,
                alpha=opacity, color='#ffbfc0', edgecolor='#000000', label=SYS[1], hatch="//")

ax.set_xlabel('Application', fontsize=18)
ax.set_ylabel('Overhead (%)', fontsize=16)

# ax.set_yticks(np.arange(1,8))
# ax.set_yticklabels(np.arange(1,8))
ax.set_xticks(index)
ax.set_xticklabels(Algos,rotation=40)
ax.tick_params(axis='x', which='major', labelsize=13)
ax.tick_params(axis='y', which='major', labelsize=15)
ax.legend(loc='upper left',fontsize=15)

fig.tight_layout()
plt.savefig(os.path.basename(__file__).replace(".py", ".pdf"))